# sessions

A browser extension aiming to simplify coplaying in [Tribal Wars](https://www.tribalwars.net/en-dk/). Coplayers can
finally play together via a browser!

## Getting started

### Installation

1. [Download the latest version.](https://gitea.dwysokinski.me/twhelp/-/packages/generic/sessions-ext/0.1.0)
2. Unzip files.
3. In your browser, go to the Extensions page by entering ``chrome://extensions`` in a new tab.
4. Enable developer mode by clicking the toggle switch next to Developer mode.
5. Click on Load Unpacked and select the extracted folder.

![img.png](docs/extension-successfully-installed.png)

The extension has been successfully installed!

### Development

#### Setting up the environment

Prerequisites:

1. **Node.js** (LTS)
2. **Yarn**
3. **IDE/Code editor** (e.g. WebStorm, VSCode, vim, neovim)
4. **web-ext** (``yarn global add web-ext``)
5. **backend** (such as [this one](https://gitea.dwysokinski.me/twhelp/sessions))
6. **Chromium-based browser** (e.g. Chromium, Vivaldi, Brave)

```shell
# install dependencies
yarn install

# start a dev server
yarn watch

# launch a browser (e.g. Chromium)
yarn run:chromium
```

## FAQ

1. What data are sent to the backend? - Only sid (session identifier). Sid
   is [encrypted/decrypted on the client side](./src/crypto.ts).

## License

Distributed under the MIT License. See ``LICENSE`` for more information.

## Contact

Dawid Wysokiński - [contact@dwysokinski.me](mailto:contact@dwysokinski.me)
